'CSql.inc

Class CSql
  Instance m_strConnectionString  As String           'This class wraps a small portion of the ODBC Api.  Its useful
  Instance m_strDatabase          As String           'particularly for easing connecting to ODBC Data Sources, i.e., 
  Instance m_strDriver            As String           'Relational Databases.  However, I don't personally have experience
  Instance m_strServer            As String           'with very many.  The only ones I've ever worked with or connected 
  Instance m_strDBQ               As String           'to are Microsoft Access and Microsoft Sql Server.  The process of
  Instance m_szCnStrOut           As Asciiz*512       'connecting to ODBC databases involves something termed a Connection
  Instance iBytes                 As Integer          'String.  These tend to be somewhat long and ugly concatenations of
  Instance swStrLen               As Integer          'KEYWORD=VALUE pairs delimited by semicolons.  For example, one of
  Instance m_hEnvr                As Dword            'the important keywords is DRIVER.  For connecting to Sql Server you
  Instance m_hConn                As Dword            'would have then this - "DRIVER=Sql Server;".  Another important
  Instance m_iNativeErrPtr        As Long             'keyword is 'SERVER'.  In the case of Microsoft's free Sql Server
  Instance m_iTextLenPtr          As Integer          'Express, to connect it wants the name of your computer (the one I'm
  Instance m_szErrCode            As Asciiz*8         'writing this on is 'CODEWARRIOR') followed with a slash and 
  Instance m_szErrMsg             As Asciiz*512       'SQLEXPRESS, i.e., SERVER=CODEWARRIOR\SQLEXPRESS.  The resulting
  Instance m_blnConnected         As Long             'connection string would then look something like this...

  Interface ISql : Inherit IUnknown                   '"DRIVER=Sql Server;SERVER=CODEWARRIOR\SQLEXPRESS" 
    Property Get strDatabase() As String
      Property=m_strDatabase                          'This sort of construction lends itself to easy automation by just
    End Property                                      'including String members of a Class for the various Keywords, and
    Property Set strDatabase(Byval strName As String) 'then just having some kind of MakeConnectionString() function in
      m_strDatabase=strName                           'the class to concatenate the necessary keyword/value pairs together
    End Property                                      'to build up the Connection String.  You can see that below in my
                                                      'MakeConnectionString() function which is just called from
    Property Get strDriver() As String                'ODBCConnect().  In order to connect to a specific DRIVER/SERVER
      Property=m_strDriver                            'then all you need do is instantiate an instance of this class and
    End Property                                      'interface in your program, set a few necessary keyword/attribute
    Property Set strDriver(Byval strName As String)   'pairs, and call ODBCConnect(). For example, to connect to a local
      m_strDriver=strName                             'Sql Server Express installed on your workstation, but not to any
    End Property                                      'specific DATABASE maintained by that Sql Server, you could do this...

    Property Get strServer() As String                'Local strComputerName As String
      Property=m_strServer                            'Local Sql As ISql
    End Property                                      
    Property Set strServer(Byval strName As String)   'Let Sql=Class "CSql"
      m_strServer=strName                             'Sql.strDriver="Sql Server"
    End Property                                      'Host Name To strComputerName
                                                      'Sql.strServer=strComputerName & "\SQLEXPRESS"
    Property Get hConn() As Dword                     'Call ODBCConnect()
      Property=m_hConn                                'If Sql.blnConnected = %TRUE Then
    End Property                                      '   ....
                                                      '   .... do your stuff!
    Property Get strDBQ() As String                   '   ...
      Property=m_strDBQ                               '   Call ODBCDisconnect()
    End Property                                      'Else  'Oh No!  Failure!  Why????
    Property Set strDBQ(Byval strName As String)      '   Print "Sql.strErrMsg      = " Sql.strErrMsg 
      m_strDBQ=strName                                '   Print "Sql.iNativeErrCode = " Sql.iNativeErrCode
    End Property                                      'End If
                                                      '
    Property Get strConnectionString() As String      'However, my MakeConnectionString() function is limited by my
      Property=m_strConnectionString                  'limited knowledge of databases to connect to, which as I have
    End Property
    Property Set strConnectionString(Byval strName As String)
      m_strConnectionString=strName               
    End Property                                      'said, are only a few Microsoft products.  If you have some other
                                                      'database you want to connect to, such as MySql, for example, and 
    Property Get blnConnected() As Long               'you want to use my class here, you'll have to build the connection 
      Property=m_blnConnected                         'string yourself and then call ODBCConnect().  If you look down at
    End Property                                      'my MakeConnectionString() function, you'll see it first checks to
    Property Set blnConnected(Byval iConnected As Long)
      m_blnConnected=iConnected
    End Property                                      'see if m_strConnectionString is "" before setting any of the other
                                                      'attribute-value pairs.  So, if you have a connection string for 
    Property Get strErrCode() As String               'some database that already works for you, just do as I've done
      Property=m_szErrCode                            'above in terms of declaring the variables, and set the
    End Property                                      'm_strConnectionString property directly using the class accessor
                                                      'property function, i.e.,
    Property Get strErrMsg() As String
      Property=m_szErrMsg                             'Sql.strConnectionString="DRIVER=SQL Server;SERVER=CODEWARRIOR\SQLEXPRESS;UID=;WSID=CODEWARRIOR;Trusted_Connection=Yes"  
    End Property                                      'Call ODBCConnect()

    Property Get iNativeErrCode() As Long             'If you have a database you want to connect to and don't have a
      Property=m_iNativeErrPtr                        'connection string, then you'll need to find one.  Go on the internet
    End Property                                      'and do a search for 'Connection Strings'.  There are lots of web 
                                                      'sites where good folks have posted connection strings for various
    Method MakeConnectionString()                     'data sources/databases.  Once you've got it working, perhaps you'll
      If m_strConnectionString="" Then                'want to break it down into piecies as I've done and modify the code 
         Select Case m_strDriver                      'just below.  If you get one working I'd be real happy if you would
           Case "SQL Server"                          'let me know about it so I could perhaps add it to my code here.
             If m_strDBQ="" Then
                m_strConnectionString= _
                "DRIVER="              & m_strDriver        & ";" & _
                "SERVER="              & m_strServer        & ";"
             Else
                m_strConnectionString= _
                "DRIVER="              & m_strDriver        & ";" & _
                "SERVER="              & m_strServer        & ";" & _
                "DATABASE="            & m_strDatabase      & ";" & _
                "DBQ="                 & m_strDBQ           & ";"
             End If
           Case "Microsoft Access Driver (*.mdb)"
             m_strConnectionString= _
             "DRIVER="                 & m_strDriver        & ";" & _
             "DBQ="                    & m_strDBQ           & ";"
           Case "Microsoft Excel Driver (*.xls)"
             m_strConnectionString= _
             "DRIVER="                 & m_strDriver        & ";" & _
             "DBQ="                    & m_strDBQ           & ";"
         End Select
      End If
    End Method

    Method ODBCConnect()
      Local szCnIn As Asciiz*512, szCnOut As Asciiz*512
      Local iRet As Long

      Me.MakeConnectionString()
      Call SQLAllocHandle(%SQL_HANDLE_ENV,%SQL_NULL_HANDLE,m_hEnvr)
      Call SQLSetEnvAttr(m_hEnvr,%SQL_ATTR_ODBC_VERSION,ByVal %SQL_OV_ODBC3,%SQL_IS_INTEGER)
      Call SQLAllocHandle(%SQL_HANDLE_DBC,m_hEnvr,m_hConn)
      szCnIn=m_strConnectionString
      iRet=SQLDriverConnect(m_hConn,0,szCnIn,Len(szCnIn),szCnOut,512,iBytes,%SQL_DRIVER_NOPROMPT)
      If iRet=0 Or iRet=1 Then
         m_blnConnected=%TRUE
      Else
         m_blnConnected=%FALSE
         Call SQLGetDiagRec(%SQL_HANDLE_DBC,m_hConn,1,m_szErrCode,m_iNativeErrPtr,m_szErrMsg,512,m_iTextLenPtr)
      End If
    End Method
    
    Method ODBCGetDiagRec(Byval hStmt As Dword)
      Call SQLGetDiagRec(%SQL_HANDLE_STMT,hStmt,1,m_szErrCode,m_iNativeErrPtr,m_szErrMsg,512,m_iTextLenPtr)
    End Method

    Method ODBCDisconnect()
      If Me.blnConnected=%TRUE Then
         Call SQLDisconnect(m_hConn)                  'Disconnect From Data Source
         Call SQLFreeHandle(%SQL_HANDLE_DBC,m_hConn)  'Free Connection Handle
         Call SQLFreeHandle(%SQL_HANDLE_ENV,m_hEnvr)  'Free Environment Handle
      End If
    End Method
  End Interface
End Class
