'SqlDemo.inc
'%MyDebug                             =     %TRUE  'unremark this to get lots of debug output

'SQLConfigDataSource request flags
%ODBC_ADD_DSN                        =     1
%ODBC_CONFIG_DSN                     =     2
%ODBC_REMOVE_DSN                     =     3
%ODBC_ADD_SYS_DSN                    =     4
%ODBC_CONFIG_SYS_DSN                 =     5
%ODBC_REMOVE_SYS_DSN                 =     6

'SQLInstallerError code
%ODBC_ERROR_GENERAL_ERR              =     1
%ODBC_ERROR_INVALID_BUFF_LEN         =     2
%ODBC_ERROR_INVALID_HWND             =     3
%ODBC_ERROR_INVALID_STR              =     4
%ODBC_ERROR_INVALID_REQUEST_TYPE     =     5
%ODBC_ERROR_COMPONENT_NOT_FOUND      =     6
%ODBC_ERROR_INVALID_NAME             =     7
%ODBC_ERROR_INVALID_KEYWORD_VALUE    =     8
%ODBC_ERROR_INVALID_DSN              =     9
%ODBC_ERROR_INVALID_INF              =    10
%ODBC_ERROR_REQUEST_FAILED           =    11  'you'll get this if db already exists
%ODBC_ERROR_INVALID_PATH             =    12
%ODBC_ERROR_LOAD_LIB_FAILED          =    13
%ODBC_ERROR_INVALID_PARAM_SEQUENCE   =    14
%ODBC_ERROR_INVALID_LOG_FILE         =    15
%ODBC_ERROR_USER_CANCELED            =    16
%ODBC_ERROR_USAGE_UPDATE_FAILED      =    17
%ODBC_ERROR_CREATE_DSN_FAILED        =    18
%ODBC_ERROR_WRITING_SYSINFO_FAILED   =    19
%ODBC_ERROR_REMOVE_DSN_FAILED        =    20
%ODBC_ERROR_OUT_OF_MEM               =    21
%ODBC_ERROR_OUTPUT_STRING_TRUNCATED  =    22

'Button Controls in SqlDemo.bas
%IDC_SQL_DRIVERS                     =  2000
%IDC_EXCEL                           =  2005
%IDC_MS_ACCESS                       =  2010
%IDC_SQL_SERVER_EXPRESS              =  2015


Type WndEventArgs
  wParam                             As Long
  lParam                             As Long
  hWnd                               As Dword
  hInst                              As Dword
End Type


Type MessageHandler
  wMessage                           As Long
  dwFnPtr                            As Dword
End Type


Global MsgHdlr()                     As MessageHandler
Global frmOutputHdlr()               As MessageHandler
Declare Function                     FnPtr(wea As WndEventArgs) As Long

'The following two function declares are from ODBCCP32.h (Installer Dll)
Declare Function SQLConfigDataSource Lib "ODBCCP32.DLL" Alias "SQLConfigDataSource" _
( _
  ByVal hParnt As Dword, _
  ByVal iReqst As Word, _
  szDriver As Asciiz, _
  szAttr As Asciiz _
) As Integer

Declare Function SQLInstallerError Lib "ODBCCP32.DLL" Alias "SQLInstallerError" _
( _
  ByVal iErr As Word, _
  ByRef pErrCode As Dword, _
  ByRef szErrMsg As Asciiz, _
  ByVal cbMsgBuffer As Word, _
  ByRef cbRet As Word _
) As Integer          

#If %Def(%MyDebug)
    Global fp As Long
#EndIf


Sub ErrorMemFree(Byval pLns As Dword Ptr, Byval iNum As Dword)
  Register i As Long        'If there are any memory allocation errors
  For i=0 To iNum           'anywhere along the way, this little thingy
    If @pLns[i] Then        'unravels all the allocations done up to the
       GlobalFree(@pLns[i]) 'point where the 1st allocation error occurred.
    End If   
  Next i
  GlobalFree(pLns)  
End Sub


Sub Prnt(Byval hWnd As Dword, Byref Sql As ISql, Byval ptrLines As Dword Ptr, Byref iLine As Long, Byval pszStr As Asciiz Ptr)
  Local iLen As Long                            'This procedure is somewhat central to the app and is used many times.  Its a
                                                'wrapper to encapsulate the process of allocating memory for a line of text to
  iLen=Len(@pszStr)                             'be eventually output to the output screen.  A pointer to the line of text is
  @ptrLines[iLine]=GlobalAlloc(%GPTR,iLen+1)    'passed into the Sub in the last parameter - pszStr.  An allocation is made for
  If @ptrLines[iLine] Then                      'enough memory to hold the string plus a null terminator.  Then the characters 
     CopyMemory(@ptrLines[iLine],pszStr,iLen)   'are copied to the address of the allocated memory.  ptrLines is a memory
     Incr iLine                                 'buffer allocated elsewhere that holds all the line pointers allocated here when
  Else                                          'a line of text is passed in.  ptrLines is stored in the .cbWndExtra bytes of
     MessageBox(hWnd,"Memory Allocation Error!","Not Good!",%MB_ICONERROR)  'the frmOutput Screen (@offset 4).  If a memory
     Call ErrorMemFree(ptrLines,iLine)          'allocation fails, ErrorMemFree() unravels all the memory allocations made up
     Sql.ODBCDisconnect()                       'to the point of the failure.
  End If    
End Sub


