'frmOutput

Function frmOutput_OnCreate(Wea As WndEventArgs) As Long                 'Offset    What's Stored There
  Local hFont,hTmp,hDC As Dword                                          '================================
  Local tm As TEXTMETRIC                                                 '0  -  3   iLineCount
                                                                         '4  -  7   ptrPtrBuffer
  #If %Def(%MyDebug)                                                     '8  -  11  cyChar
      Print #fp, "  Entering frmOutput_OnCreate()"                       '12 -  15  si.nPos, i.e., iStart
  #EndIf                                                                       
  hDC=GetDC(Wea.hWnd)                                                    
  hFont=CreateFont(16,0,0,0,%FW_BOLD,0,0,0,0,0,0,2,0,"Courier New")      'For tabular data you need
  hTmp=SelectObject(hDC,hFont)                                           'a fixed pitch font, and the
  Call GetTextMetrics(hDC,tm)                                            'size of a char in this font
  Call SetWindowLong(Wea.hWnd,8,tm.tmHeight)                             'is information you have to
  Call DeleteObject(SelectObject(hDC,hTmp))                              'have to set up scrolling.
  Call ReleaseDC(Wea.hWnd,hDC)                                           'Another piece of information
  Call SetWindowLong(Wea.hWnd,12,0)                                      'that has to persist is the
  #If %Def(%MyDebug)                                                     'scrolling position of the
      Print #fp, "  Leaving frmOutput_OnCreate()" : Print #fp,           'window.  Here its initially
  #EndIf                                                                 'set to zero and stored in the
                                                                         '.cbWndExtra bytes at offset 12.
  frmOutput_OnCreate=0
End Function


Function frmOutput_OnPaint(Wea As WndEventArgs) As Long
  Local hDC,iLineCount,i,iStart,iFinish,iLine,iPos,hFont,hTmp As Dword
  Local ptrPtrBuffer As Dword Ptr
  Local pszStr As Asciiz Ptr
  Local ps As PAINTSTRUCT
  Local cyChar As Long
  
  iLineCount=GetWindowLong(Wea.hWnd,0)                  'How Many Lines In Scroll Buffer?
  ptrPtrBuffer=GetWindowLong(Wea.hWnd,4)                'Buffer Holding String Pointers
  cyChar=GetWindowLong(Wea.hWnd,8)                      'How High Is Each Line?
  iPos=GetWindowLong(Wea.hWnd,12)                       'What's The Top Line Number?
  hDC=BeginPaint(Wea.hWnd,ps)                           'Need A Device Context To Print In Windows!
  iStart=Fix(ps.rcPaint.nTop/cyChar)                    'Gotta Find Bounds Of Invalid Region In
  iFinish=ps.rcPaint.nBottom/cyChar                     'Terms Of Top & Bottom.
  hFont=CreateFont(16,0,0,0,%FW_BOLD,0,0,0,0,0,0,2,0,"Courier New")
  hTmp=SelectObject(hDC,hFont)
  Call SetBkMode(hDC,%TRANSPARENT)
  For i=iStart To iFinish
    iLine=iPos+i
    If iLine<iLineCount Then
       If @ptrPtrBuffer[iLine] Then
          pszStr=@ptrPtrBuffer[iLine]
          Call TextOut(hDC,0,i*cyChar,Byval @ptrPtrBuffer[iLine],Len(@pszStr))
       End If
    End If   
  Next i 
  Call DeleteObject(SelectObject(hDC,hTmp))
  Call EndPaint(Wea.hWnd,ps)
   
  frmOutput_OnPaint=0
End Function


Function frmOutput_OnSize(Wea As WndEventArgs) As Long
  Local iLinesVisible,iLineCount,cyChar As Long
  Local si As SCROLLINFO
  
  iLineCount=GetWindowLong(Wea.hWnd,0)
  si.cbSize = Sizeof(SCROLLINFO)
  si.fMask = %SIF_POS Or %SIF_RANGE
  Call GetScrollInfo(Wea.hWnd,%SB_VERT,si)             'When a WM_SIZE message comes through, the
  cyChar=GetWindowLong(Wea.hWnd,8)                     'HIWRD(lParam) contains the client height
  iLinesVisible=HIWRD(Wea.lParam)/cyChar               'of the Window in pixels.  This, in conjunc-
  'si.cbSize = Sizeof(SCROLLINFO);                     'tion with the cyChar info stored in the
  si.fMask =   %SIF_POS Or %SIF_RANGE                  '.cbWndExtra bytes, can be used to determine
  si.nMin = 0                                          'the number of lines visible in the window.
  si.nMax = iLineCount-iLinesVisible
  si.nPos=GetWindowLong(Wea.hWnd,12)
  If si.nMax<0 Then
     si.nMax=0
  End If   
  Call SetScrollInfo(Wea.hWnd,%SB_VERT,si,%TRUE) 

  frmOutput_OnSize=0
End Function


Function frmOutput_OnVScroll(Wea As WndEventArgs) As Long
  Local iLinesVisible As Long
  Local si As SCROLLINFO
  Local rc As RECT
  
  si.nPos=GetWindowLong(Wea.hWnd,12)
  Select Case As Long Lowrd(Wea.wParam)
    Case %SB_LINEUP
      If si.nPos Then
         si.cbSize = Sizeof(SCROLLINFO)
         Decr si.nPos
         Call SetWindowLong(Wea.hWnd,12,si.nPos)
         si.fMask = %SIF_POS
         Call SetScrollInfo(Wea.hWnd,%SB_VERT,si,%TRUE)
         Call ScrollWindow(Wea.hWnd,0,GetWindowLong(Wea.hWnd,8),Byval 0, Byval 0)
      End If
    Case %SB_PAGEUP
       Call GetClientRect(Wea.hWnd,rc)
       iLinesVisible=rc.nBottom/GetWindowLong(Wea.hWnd,8)
       si.cbSize = Sizeof(SCROLLINFO)
       si.nPos=si.nPos-iLinesVisible
       If si.nPos<0 Then
          si.nPos=0
       End If   
       Call SetWindowLong(Wea.hWnd,12,si.nPos)
       si.fMask = %SIF_POS
       Call SetScrollInfo(Wea.hWnd,%SB_VERT,si,%TRUE)
       Call ScrollWindow(Wea.hWnd,0,rc.nBottom,Byval 0,Byval 0)
    Case %SB_LINEDOWN
      si.cbSize = Sizeof(SCROLLINFO)
      si.fMask = %SIF_POS Or %SIF_RANGE
      Call GetScrollInfo(Wea.hWnd,%SB_VERT,si)
      If si.nPos<si.nMax Then
         Incr si.nPos
         Call SetWindowLong(Wea.hWnd,12,si.nPos)
         si.fMask = %SIF_POS
         Call SetScrollInfo(Wea.hWnd,%SB_VERT,si,%TRUE)
         Call ScrollWindow(Wea.hWnd, 0, -GetWindowLong(Wea.hWnd,8), Byval 0, Byval 0)
      End If
    Case %SB_PAGEDOWN   
       si.cbSize = Sizeof(SCROLLINFO)
       si.fMask = %SIF_POS Or %SIF_RANGE
       Call GetScrollInfo(Wea.hWnd,%SB_VERT,si)
       Call GetClientRect(Wea.hWnd,rc)
       iLinesVisible=rc.nBottom/GetWindowLong(Wea.hWnd,8)
       If iLinesVisible+si.nPos<=si.nMax Then
          si.nPos = si.nPos + iLinesVisible
       else
          si.nPos=si.nMax
       End If   
       Call SetWindowLong(Wea.hWnd,12,si.nPos)
       si.fMask = %SIF_POS
       Call SetScrollInfo(Wea.hWnd,%SB_VERT,si,%TRUE)
       Call ScrollWindow(Wea.hWnd,0,rc.nBottom,Byval 0,Byval 0)
  End Select
  
  frmOutput_OnVScroll=0
End Function


Function frmOutput_OnClose(Wea As WndEventArgs) As Long
  Local ptrPtrBuffer As Dword Ptr
  Local iLineCount,blnFree As Long
  Local pszStr As Asciiz Ptr
  Register i As Long
  
  #If %Def(%MyDebug)
      Print #fp, "Entering frmOutput_OnClose()"
  #EndIf     
  iLineCount=GetWindowLong(Wea.hWnd,0)
  ptrPtrBuffer=GetWindowLong(Wea.hWnd,4)
  #If %Def(%MyDebug)
      Print #fp, "  iLineCount            = " iLineCount
      Print #fp, "  ptrPtrBuffer          = " ptrPtrBuffer
      Print #fp,
      For i=0 To iLineCount-1
        If @ptrPtrBuffer[i] Then
           pszStr=@ptrPtrBuffer[i]
           Print #fp, " " i, @ptrPtrBuffer[i], @pszStr
        Else
           Print #fp, " " i, "NULL"
        End If      
      Next i 
      Print #fp,
  #EndIf       
  For i=0 To iLineCount-1
    If @ptrPtrBuffer[i] Then
       #If %Def(%MyDebug)
           Print #fp, " " i, GlobalFree(@ptrPtrBuffer[i])
       #Else
           GlobalFree(@ptrPtrBuffer[i])    
       #EndIf
    Else
       #If %Def(%MyDebug)
           Print #fp, " " i, "Not Allocated!"
       #EndIf     
    End If      
  Next i 
  #If %Def(%MyDebug)
      Print #fp,
  #EndIf    
  blnFree=GlobalFree(ptrPtrBuffer)
  #If %Def(%MyDebug)
      Print #fp, "  blnFree(ptrPtrBuffer) = " blnFree
  #EndIf    
  Call DestroyWindow(Wea.hWnd)
  #If %Def(%MyDebug)  
      Print #fp, "Leaving frmOutput_OnCreate()" : Print #fp,
  #EndIf  

  frmOutput_OnClose=0
End Function


Function frmOutput(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Local Wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 4
    If wMsg=frmOutputHdlr(i).wMessage Then
       Wea.hWnd=hWnd : Wea.wParam=wParam : Wea.lParam=lParam
       Call Dword frmOutputHdlr(i).dwFnPtr Using FnPtr(Wea) To iReturn
       frmOutput=iReturn
       Exit Function
    End If
  Next i

  frmOutput=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function
